module HeapTree (HTree) where

import SigHeap 

data Ord a => HTree a = Null | Fork a (HTree a) (HTree a)

instance Heap HTree where

   empty = Null

   isEmpty Null = True
   isEmpty _    = False

   minElem (Fork x _ _) = x

   deleteMin (Fork _ a b) = merge a b

   insert x ht = merge (Fork x Null Null) ht

   merge l Null = l
   merge Null r = r
   merge l@(Fork x a b) r@(Fork y c d) 
    | x<y  = let (p,q) = reduce2 a b r 
             in Fork x p q  
    | x>=y = let (p,q) = reduce2 l c d
             in Fork y p q 
    where reduce2 a b c = (a, merge b c)
                       -- (b, merge a c)
                       -- (c, merge a b)
                       -- (merge b c, a)
                       -- (merge a c, b)
                       -- (merge a b, c)

 
insertSort :: (Heap t, Ord a) => t a -> [a] -> [a]
insertSort nullTree xs = let heap = foldl (flip insert) nullTree xs
                         in fromHeap heap
