module MPHeapTree (MPTree) where

import SigHeap

data Ord a => MPTree a = Null | Fork Int a (MPTree a) (MPTree a)

instance Heap MPTree where

  empty = Null

  isEmpty Null = True
  isEmpty (Fork _ _ _ _) = False

  minElem (Fork _ x _ _) = x

  deleteMin (Fork _ _ a b) = merge a b

  insert x ht = merge (Fork 1 x Null Null) ht

  merge l Null = l
  merge Null r = r
  merge a b 
   | minElem a <= minElem b = join a b
   | otherwise              = join b a
   where 
    join (Fork n x a b) c = Fork (n + size c) x aa (merge bb cc) where
       (aa,bb,cc) = orderBySize a b c
       orderBySize a b c  
        | size a == biggest = (a,b,c)
        | size b == biggest = (b,a,c)
        | size c == biggest = (c,a,b)
       biggest = size a `max` size b `max` size c
       size Null = 0
       size (Fork n _ _ _) = n

