module QuicksortST(quicksortST) where

import Array
import Monad
import Control.Monad.ST
import Data.Array.ST

quicksort :: Ord a => (Int,Int) -> STArray st Int a 
                                -> ST st ()
quicksort (lower,upper) arr
 = if lower>=upper
      then return ()
      else do
            pivot <- readArray arr lower 
            (i,j) <- partition arr pivot (lower,upper)
            quicksort (lower,j) arr
            quicksort (i,upper) arr

quicksortST :: Ord a => [a] -> [a]
quicksortST xs = 
 runST (do
         let n = length xs
         arr <- newArray (0,n-1) undefined
         mapM (\i -> writeArray arr i (xs!!i)) [0..n-1]
         quicksort (0,n-1) arr
         ys <- mapM (readArray arr) [0..n-1]
         return ys)

partition :: Ord a => STArray st Int a -> a -> (Int,Int) 
                                           -> ST st (Int,Int)
partition arr pivot
 = while (\ (i,j) -> return (i<=j))
         (\ (i,j) -> do {
    i <- while (\i -> do x <- readArray arr i 
                         return (x < pivot))
               (\i -> return (i+1)) i ;
    j <- while (\j -> do x <- readArray arr j
                         return (x > pivot))
               (\j -> return (j-1)) j ;
    if (i<=j) then (do xi <- readArray arr i
                       xj <- readArray arr j
                       writeArray arr i xj
                       writeArray arr j xi 
                       return (i+1,j-1))
              else return (i,j) } )

while ::    (a -> ST st Bool)  -- Eintrittsbedingung 
         -> (a -> ST st a)     -- Schleifenrumpf
         -> a                  
         -> ST st a
while p f x = do
               cont <- p x
               if cont then do
                             x <- f x
                             while p f x
                       else return x
