module RRHeapTree (RRTree) where

import SigHeap

data Ord a => RRTree a = Null 
                       | ForkA a (RRTree a) (RRTree a)
                       | ForkB a (RRTree a) (RRTree a)

instance Heap RRTree where

   empty = Null

   isEmpty Null = True
   isEmpty _    = False

   minElem (ForkA x _ _) = x
   minElem (ForkB x _ _) = x

   deleteMin (ForkA _ a b) = merge a b
   deleteMin (ForkB _ a b) = merge a b

   insert x ht = merge (ForkA x Null Null) ht

   merge l Null = l
   merge Null r = r
   merge a b 
    | minElem a <= minElem b = join a b
    | otherwise              = join b a
    where
      join (ForkA x a b) c = ForkB x (merge a c) b
      join (ForkB x a b) c = ForkA x a (merge b c)

