module SkewHeapTree (SkewTree) where

import SigHeap

data Ord a => SkewTree a = Null 
                         | Fork a (SkewTree a) (SkewTree a)

instance Heap SkewTree where

   empty = Null

   isEmpty Null = True
   isEmpty _    = False

   minElem (Fork x _ _) = x

   deleteMin (Fork _ a b) = merge a b

   insert x ht = merge (Fork x Null Null) ht

   merge l Null = l
   merge Null r = r
   merge a b 
    | minElem a <= minElem b = join a b
    | otherwise              = join b a
    where
       join (Fork x a b) c = Fork x b (merge a c) 

